#property  copyright "Adeo" 
#property  link      "adeomercatus@yahoo.com"

#property indicator_separate_window
#property indicator_buffers    2
#property indicator_color1     DeepSkyBlue
#property indicator_color2     Maroon
#property indicator_levelcolor DimGray
#property indicator_level1     0.0

//
//
//
//
//

extern string palTimeFrame      = "Current time frame";
extern int    palShowValue      =  1;
extern int    palType           =  0;
extern int    palEmaPeriod      =  1;
extern int    palLookback       =  1;
extern double palSmoothLength   =  1;
extern double palSmoothPhase    =  0;
extern bool   palSmoothDouble   = false;
extern bool   palInterpolate    = true;
extern bool   palShowTrigger    = false;
//
//
//
//
//

double value[];
double trigger[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   palShowValue = MathMax(MathMin(palShowValue,19),0);
   palEmaPeriod = MathMax(palEmaPeriod,1);
      string name = "";
      switch (palShowValue)
      {   
         case  0 : name = "pal Line";        break;
         case  1 : name = "pal aLine";       break;
         case  2 : name = "pal Span";        break;
         case  3 : name = "pal aSpan";       break;
         case  4 : name = "pal Area";        break;
         case  5 : name = "pal aArea";       break;
         case  6 : name = "pal Mom";         break;
         case  7 : name = "pal aMom";        break;
         case  8 : name = "pal Mod";         break;
         case  9 : name = "pal aMod";        break;
         case 10 : name = "pal TOW";         break;
         case 11 : name = "pal aTOW";        break;
         case 12 : name = "pal Dir";         break;
         case 13 : name = "pal aDir";        break;
         case 14 : name = "pal Atr";         break;
         case 15 : name = "pal aAtr";        break;
         case 16 : name = "pal Frc";         break;
         case 17 : name = "pal aFrc";        break;
         case 18 : name = "pal Tgl";         break;
         case 19 : name = "pal aTgl";        break;
      }         

      SetIndexBuffer(0,value); SetIndexLabel(0,name);
      SetIndexBuffer(1,trigger); SetIndexLabel(1, "trigger");
      SetLevelValue(0,0.0);
      
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = palTimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = palTimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(palTimeFrame);
   
   IndicatorShortName(timeFrameToString(timeFrame)+" "+name+" ("+palShowValue+", "+palType+", "+DoubleToStr(palEmaPeriod,0)+", "+palLookback+")");
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][21];
#define palLine       0 
#define palaLine      1 
#define palSpan       2
#define palaSpan      3
#define palArea       4 
#define palaArea      5 
#define palMom        6
#define palaMom       7
#define palMod        8
#define palaMod       9
#define palTOW       10
#define palaTOW      11
#define palDir       12
#define palaDir      13
#define palAtr       14
#define palaAtr      15
#define palFrc       16
#define palaFrc      17
#define palTgl       18
#define palaTgl      19
#define palDirUpDn   20

//
//
//
//
//

int start()
{
   int i,r,limit,counted_bars = IndicatorCounted();
      
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { value[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //
    
   if(calculateValue || timeFrame == Period())
   {
      if(ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
            
      //
      //
      //
      //
      //
            
      double emaFactor = 2.0/(1.0+palEmaPeriod);
      double point     = Point; if (Digits==3 || Digits==5) point *= 10;
      for (i=limit, r=Bars-i-1; i >= 0; i--, r++)
      {
         if (palType==0){
            double H  = iHigh(NULL,0,i);
            double PH = iHigh(NULL,0,i+1);
            double L  = iLow(NULL,0,i);
            double PL = iLow(NULL,0,i+1);
            double C  = iClose(NULL,0,i);
            double PC = iClose(NULL,0,i+1);
         }else{
            H  = MathMax(iOpen(NULL,0,i),  iClose(NULL,0,i));
            PH = MathMax(iOpen(NULL,0,i+1),iClose(NULL,0,i+1));
            L  = MathMin(iOpen(NULL,0,i),  iClose(NULL,0,i));
            PL = MathMin(iOpen(NULL,0,i+1),iClose(NULL,0,i+1));
            C  = (H  + L) /2;
            PC = (PH + PL)/2;
         }
         //
         //
         //
         //
         //
            
         work[r][palLine]     = (H + L - PH - PL) / point;            //Base pal is ((H-pL) + (L-pH))
         work[r][palaLine]    = (emaFactor*(work[r][palLine]))+((1-emaFactor)*work[r-1][palaLine]);          
         work[r][palSpan]     = (PH - PL) / point;                    //ATR-like measure of volatility
         work[r][palaSpan]    = (emaFactor*(work[r][palSpan]))+((1-emaFactor)*work[r-1][palaSpan]); 
         work[r][palArea]     = 0;                                    //Area under the pal Line curve
               for (int j = 0; j<palLookback; j++) work[r][palArea] += work[r-j][palLine];
         work[r][palaArea]    = (emaFactor*(work[r][palArea]))+((1-emaFactor)*work[r-1][palaArea]); 
         work[r][palMom]      = work[r][palArea] * MathAbs(work[r][palSpan]);  //Momentum         
         work[r][palaMom]     = (emaFactor*(work[r][palMom]))+((1-emaFactor)*work[r-1][palaMom]); 
         work[r][palMod]      = (C + C - PH - PL) / point;            //Moderated value
         work[r][palaMod]     = (emaFactor*(work[r][palMod]))+((1-emaFactor)*work[r-1][palaMod]); 

         int palSign =-1.0;
                  if(MathAbs(H-PL) >= MathAbs(L-PH)) palSign=1;
                  if(palSign==1.0){
                     if (MathAbs(L-PH)!=0.0)
                        work[r][palTOW] =  palSign*(MathAbs(H-PL)/MathAbs(L-PH));
                        work[r][palTOW] =  work[r-1][palTOW];    //Tug Of War between Bulls & Bears
                  }else{
                     if (MathAbs(H-PL)!=0.0)
                        work[r][palTOW] =  palSign*(MathAbs(L-PH)/MathAbs(H-PL));
                     else
                        work[r][palTOW] =  work[r-1][palTOW];
                  }      
         work[r][palaTOW] = (emaFactor*(work[r][palTOW]))+((1-emaFactor)*work[r-1][palaTOW]);          
      
         if (MathAbs(H-PL) >= MathAbs(L-PH))
              work[r][palDirUpDn] = (H-PL)/point;                         //Direction of movement
         else work[r][palDirUpDn] = (L-PH)/point;
               work[r][palDir] = 0.0;
               for (j = 0; j<palLookback; j++) 
               {
                  if(work[r-j][palDirUpDn] >= 0.0)
                     work[r][palDir]++;
                  else
                     work[r][palDir]--;
               }
         work[r][palaDir]    = (emaFactor*(work[r][palDir]))+((1-emaFactor)*work[r-1][palaDir]); 

         work[r][palFrc]     = work[r][palDir] * MathAbs(work[r][palSpan]);  //Force         
         work[r][palaFrc]    = (emaFactor*(work[r][palFrc]))+((1-emaFactor)*work[r-1][palaFrc]); 


         if (MathAbs(H-PC) >= MathAbs(L-PC))
            if (H >= PC)
               work[r][palAtr] =  (H-PC)/point/100.0;
            else
               work[r][palAtr] =  (PC-H)/point/100.0;
            else
            if (L <= PC)
               work[r][palAtr] =  (L-PC)/point/100.0;
            else
               work[r][palAtr] =  (PC-L)/point/100.0;

         work[r][palaAtr] = (emaFactor*(work[r][palAtr]))+((1-emaFactor)*work[r-1][palaAtr]);          

         if(MathAbs(H-PL) >= MathAbs(L-PH))
            work[r][palTgl] =  (H-PL);
         else
            work[r][palTgl] =  (L-PH);

         work[r][palaTgl] = (emaFactor*(work[r][palTgl]))+((1-emaFactor)*work[r-1][palaTgl]);          
      

         //
         //
         //
         //
         //
      
         switch (palShowValue)
         {   
            case  0 : value[i] = iDSmooth(palSmoothDouble,work[r][palLine]    ,palSmoothLength,palSmoothPhase,i); break;
            case  1 : value[i] = iDSmooth(palSmoothDouble,work[r][palaLine]   ,palSmoothLength,palSmoothPhase,i); break;
            case  2 : value[i] = iDSmooth(palSmoothDouble,work[r][palSpan]    ,palSmoothLength,palSmoothPhase,i); break;
            case  3 : value[i] = iDSmooth(palSmoothDouble,work[r][palaSpan]   ,palSmoothLength,palSmoothPhase,i); break;
            case  4 : value[i] = iDSmooth(palSmoothDouble,work[r][palArea]    ,palSmoothLength,palSmoothPhase,i); break;
            case  5 : value[i] = iDSmooth(palSmoothDouble,work[r][palaArea]   ,palSmoothLength,palSmoothPhase,i); break;
            case  6 : value[i] = iDSmooth(palSmoothDouble,work[r][palMom]     ,palSmoothLength,palSmoothPhase,i); break;
            case  7 : value[i] = iDSmooth(palSmoothDouble,work[r][palaMom]    ,palSmoothLength,palSmoothPhase,i); break;
            case  8 : value[i] = iDSmooth(palSmoothDouble,work[r][palMod]     ,palSmoothLength,palSmoothPhase,i); break;
            case  9 : value[i] = iDSmooth(palSmoothDouble,work[r][palaMod]    ,palSmoothLength,palSmoothPhase,i); break;
            case 10 : value[i] = iDSmooth(palSmoothDouble,work[r][palTOW]     ,palSmoothLength,palSmoothPhase,i); break;
            case 11 : value[i] = iDSmooth(palSmoothDouble,work[r][palaTOW]    ,palSmoothLength,palSmoothPhase,i); break;
            case 12 : value[i] = iDSmooth(palSmoothDouble,work[r][palDir]     ,palSmoothLength,palSmoothPhase,i); break;
            case 13 : value[i] = iDSmooth(palSmoothDouble,work[r][palaDir]    ,palSmoothLength,palSmoothPhase,i); break;
            case 14 : value[i] = iDSmooth(palSmoothDouble,work[r][palAtr]     ,palSmoothLength,palSmoothPhase,i); break;
            case 15 : value[i] = iDSmooth(palSmoothDouble,work[r][palaAtr]    ,palSmoothLength,palSmoothPhase,i); break;
            case 16 : value[i] = iDSmooth(palSmoothDouble,work[r][palFrc]     ,palSmoothLength,palSmoothPhase,i); break;
            case 17 : value[i] = iDSmooth(palSmoothDouble,work[r][palaFrc]    ,palSmoothLength,palSmoothPhase,i); break;
            case 18 : value[i] = iDSmooth(palSmoothDouble,work[r][palTgl]     ,palSmoothLength,palSmoothPhase,i); break;
            case 19 : value[i] = iDSmooth(palSmoothDouble,work[r][palaTgl]    ,palSmoothLength,palSmoothPhase,i);
         }         
         if (palShowTrigger)  trigger[i] = value[i+1];

      }
      return(0);
   }
 
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         value[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",palShowValue,palType,palEmaPeriod,palLookback,palSmoothLength,palSmoothPhase,palSmoothDouble,0,y);
         if (palShowTrigger)  trigger[i] = value[i+1];

         //
         //
         //
         //
         //
      
         if (!palInterpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
                  value[i+k] = value[i] + (value[i+n] - value[i])*k/n;
   }
   
   //
   //
   //
   //
   //

   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double wrk[][28];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(bool isDouble, double price, double length, double phase, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (        iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}